; assemble at $8000
	org $8000

; equates
	base			equ $00
	adr				equ base + $02
	bank			equ adr + $02
	temp	        equ bank + $02
	joy_lo			equ temp + $02
	joy_hi			equ joy_lo + $01
	joy_old			equ joy_hi + $01
	random			equ joy_old + $02
	randomC			equ random + $04
	lastvar			equ randomC + $02
	
; Includes
	include "sprite.asm"	; sprite code
	include "block.asm"		; boundary check
	include "init.asm"		; basic stuff
	include "utils.asm"		; gfx utils
	include "gfx.asm"		; gfx code
	include "font.asm"		; text & font code
	include "tetris.asm"	; tetris code
	include "level.asm"		; level ctrl
	include "gamectl.asm"	; joypad & menu ctrl
	include "music.asm"		; music code
	include "dialog.asm"	; dialog system
	include "intro.asm"		; intro stage
	include "extro.asm"		; intro stage
		
programStart
	sei						; disable interrupts
	sep #$30
	lda #$00
	pha
	plb						; zero bank
	clc
	xce						; native 16-bit mode
	jsr InitSNES
	
	rep #$30
	jsr InitGfx				; Preloading
	jsr ClearMemory
	jsr TransferLoader		; setup music engine
	jsr LoadSprites			; setup sprite data
	jsr LoadFont
	
	jsr IntroBla
	jsr DisplayLogo
	jsr EntryText
	jsr SecretLab
	jsr KathrinLogin
	jsr StatusBla
	jsr SetupRandom
	sep #$20
dolevl	
	jsr ShowCastle
	jsr DoLevels
	lda.b PlayerState
	cmp #$FF
	BEQ dolevl
	jsr FinalBattle
	jsr Dead
	jsr Extro

stop_
	bra stop_				; Halt Processor

; -- Binary Data -----------------------------
	include "data.asm"