	OldPort			equ lastvar4
	lastvar5		equ	OldPort+$01


; -----------------------------------------------------------
; Transfers the main loader to spc upper ram and activates it 
; -----------------------------------------------------------

TransferLoader:
	php
	rep #$30
	lda.w #$2100								; set direct page to $2100	
	tcd

; Transfer the ff main code and the base loader by IPL

Init											; Wait for SPC700 to initialize
	lda.w #$0BBAA
_Wait1
	Cmp.b $40
	BNE	_Wait1

	lda.w #$0200								;Store destination address
	StA.b $42
	lda.w #$01CC								;Tell SPC700 we're ready to start
Trans
	StA.b $40
	sep #$20
_Wait2
	Cmp.b $40
	BNE	_Wait2

Send											; Send data
	rep #$20
	ldx.w # APUmain_fin - APUmain				;X = Number of bytes to send 
	ldy.w #$0000
	sep #$20
_Next
	lda APUmain,Y
	sta.b $41									;Byte to store
	TYA
	sta.b $40									;Byte counter
_Wait3
	Cmp.b $40
	BNE	_Wait3
	InY
	DeX
	BNE	_Next

	rep #$20									;Begin execution
	lda.w #$1A00								;Store execution address
	StA.b $42

	sep #$20
	StZ.b $41									;Write "begin execution" command

	LdA.b $40									;Tell IPL to read command
	AdC	#$02
	StA.b $40

	LdX.w #$0100 									;Wait for IPL
_Stall1
	DeX
	BNE	_Stall1

; Transfer the main loader using the base loader
	sep #$10
	ldx #$FF
	stx.b $43									; Tell the baseloader to startup
_Wait4	
	cpx.b $43
	BNE	_Wait4

	inx
	cpx.b # APUload_fin - APUload
	beq _Done

	lda APUload,X
	sta.b $40										; store a byte
	
	stx.b $43										; update the baseloader
	bra _Wait4
_Done
	lda #$FE
	sta.b $43

	rep #$20
	lda.w #$0000									; restore direct page
	tcd
	plp
	rts

; -------------------------------------------
; Transfers a compressed SoundBlk file to SPC
; -------------------------------------------

LoadMusic
	php
	sep #$10
	rep #$20

; Synchronize

	ldy #$37
_WaitSync
	cpy $2143
	BNE _WaitSync

	sty $2143

; Copy DSP registers

	ldy	#$00
_Wait5
	cpy $2143
	BNE	_Wait5

	lda (base),Y
	sta $2140
	sty $2143
	iny
	iny
		
	cmp.w #$FFFF
	BNE	_Wait5

; Copy Restore prog

	sep #$30
	ldy	#$CC
	ldx #$00
_WaitR
	cpx $2143
	BNE	_WaitR

	lda (base),Y
	sta $2140
	stx $2143
	inx
	iny
	cpx #$34
	BNE	_WaitR

; Copy RAM 1A00-FF00

	rep #$30
	stz.b adr
	ldy.w #$0302
	lda (base),Y
	sta.b adr+$02
	ldy.w #$0300
	lda (base),Y
	tay								; load hi-ram pointer to Y, bank to adr
	
	ldx.w #$00
	sep #$20
_Loop
	txa
_Wait6								; wait for mainloader
	cmp $2143
	BNE _Wait6
	
	lda $2142						; check for final condition
	BNE _Finish

	rep #$20
	lda [adr],Y
	sta $2140						; write word

	sep #$20
	cmp #$79
	BEQ _Multi						; check for multibyte

	lda #$01
	sta $2142
_Send	
	txa
	sta $2143						; store 01 multi, low y as counter
	inx
	iny
	iny
	BNE _Loop
	
	inc.b adr+$02					; page overflow
	ldy.w #$8000
	BRA _Loop

_Multi
	xba
	sta $2142						; store multi count
	iny
	iny
	BEQ _Ovl						; check for page overflow
_cont
	rep #$20
	lda [adr],Y
	sta $2140						; write data word
	sep #$20
	BRA _Send						; set counter, inc

_Ovl
	inc.b adr+$02
	ldy.w #$8000
	BRA _cont

_Finish
	lda #$37
	sta $2143						; send final acknowledge
	sta $2142

; Copy LoRAM 0000-0200

	ldy.w #$0100
	lda #$00
	tax
_Wait7								; wait for mainloader
	cmp $2143
	BNE	_Wait7

	rep #$20
	lda (base),Y
	sta $2140
	sep #$20
	iny
	iny
	txa
	sta $2143						; send word, low x as counter
	inx
	inc
	BNE	_Wait7

; Wait for Finish

	lda #$37
_Wait8
	cmp $2143
	BNE _Wait8
	plp
	rts
; -----------------------------------------
; Start previously loaded music
; -----------------------------------------

StartMusic							
	php
	rep #$20
	stz $2140
	stz $2142
	sep #$20
	stz.b OldPort
	plp
	rts

StartFX
	php
	sep #$20
	sta $2141
	cmp #$FC
	beq fx_quit
	lda #$02
fx_quit
	sta $2140
	lda.b OldPort
	inc
	sta $2143			; set commando bytes
	sta.b OldPort
not_ready
	cmp $2143
	bne not_ready
	plp
	rts

StopFX
	php
	sep #$20
	lda #$FC
	sta $2140
	sta $2143
	plp
	rts

; -----------------------------------------
; Quit the FF-Main through hack
; -----------------------------------------

StopMusic
	php
	sep #$20
	lda #$FC				; hacked quit code
	sta	$2140				; send to port 0
	plp
	rts

FFfx				; A = fx num
	php
	sep #$20
	sta $2140
	plp
	rts

FFfade
	php
	sep #$30
	ldx #$3f
ff_loop	
	lda #$0c
	sta $2141
	stx $2142
	lda #$FD
	sta $2140
	wai
	wai
	lda #$1c
	sta $2141
	stx $2142
	lda #$FD
	sta $2140
	wai
	wai
	dex
	BPL ff_loop
		
	plp
	rts
