
;equates
	blockmap	equ	$1000

LoadBlockMap
	php
	rep #$10
	sep #$20
	ldx.w #$7c00
	stx.b base
	JSR LoadMap				; load gfx data
	ldy.w #$0000
	tyx
b_loop
	lda [adr],Y
	BEQ b_store
	cmp #$57
	beq b_deadly
	cmp #$6e
	beq b_magic
	cmp #$5d
	beq b_ctrl
	cmp #$6f
	beq b_magic
	cmp #$69
	beq b_action
	lda #$01
b_store
	sta.w blockmap,X
	inx
	iny
	iny
	cpy.w #$0800
	bne b_loop
	plp
	rts

b_deadly
	lda #$40
	bra b_store
b_ctrl
	lda #$18
	bra b_store
b_action
	lda #$20
	bra b_store
b_magic
	lda #$10
	bra b_store

BoundaryCheck
	ldy.w #$05
	lda #$FF
	sta.b XBorder
	inc
	sta.b temp+$01				
	xba							; clear acc & temp high
	lda.b PlayerX
	clc
	sbc.b PlayerMove
	lsr
	lsr
	inc
	lsr
	sta.b temp					; store X adr
	lda.b PlayerY
	inc
	clc
	and #$F8
	rep #$21
	asl
	asl
	adc.b temp					; X+Y
	dec
	tax							; store map adr
	sep #$20
	lda.b PlayerMove
	BMI check_start
	inx							; modify for left
	inx
	inx
	
check_start
	lda.w blockmap-$20, X
	BEQ bc_okay
	stz.b XBorder				; found block
bc_okay
	rep #$21
	txa
	adc.w #$20
	tax
	sep #$20
	dey
	BNE check_start
							; check in Y direction	
	lda #$00
	xba							; clear acc & temp high
	lda.b PlayerX
	lsr
	lsr
	lsr
	sta.b temp					; store X adr
	lda.b PlayerY
	inc
	clc
	and #$F8
	rep #$21
	asl
	asl
	adc.b temp					; X+Y
	tax							; store map adr
	sep #$20
	lda.b PlayerState
	sta.b PlayerStateOld
	and #$84
	beq bc_start
	bmi bc_jump
	stz.b XBorder
	bra bc_above				; handle falling, jumping etc. right
bc_jump
	lda.b base
	beq bc_above
bc_start	
	lda #$01
	sta.b PlayerState			; assume falling
	
	lda.w blockmap+$81, X
	BNE bc_standing
								; test neighbour block
	lda.b PlayerX
	and #$07
	cmp #$05					; left or right ?
	BCS bc_right
	lda.w blockmap+$80,X
	BRA bc_check
bc_right
	lda.w blockmap+$82,X
bc_check
	BEQ bc_above
bc_standing
	bit #$40
	BNE bc_kill
	bit #$10
	BNE bc_magic
bc_setzero	
	stz.b PlayerState

bc_above
	lda #$00
	xba							; clear acc & temp high
	lda.b PlayerY
	adc #$05
	clc
	and #$F8
	rep #$21
	asl
	asl
	adc.b temp					; X+Y
	tax							; store map adr
	sep #$20
	
	lda.w blockmap-$1f,X
	sta.b temp
	
	lda.b PlayerX
	and #$07
	cmp #$05					; left or right ?
	BCS dbc_right
	lda.w blockmap-$20,X
	BRA dbc_chk
dbc_right
	lda.w blockmap-$1e,X
dbc_chk
	ora.b temp
	BMI bc_kill
	BEQ bc_finish
	and #$20
	BNE bc_action	
bc_fall
	lda #$01
	sta.b PlayerState			; assume falling
			
bc_finish
	rts
bc_kill
	JMP Die
bc_magic
	tay
	lda.b base
	BEQ bc_setzero
	tya
	cmp #$18
	BEQ bc_ctrl
	lda #$FE
	sta.b PlayerState
	rts
bc_ctrl
	jsr TetrisControl
	rts

bc_action
	lda #$28
	jsr FFfx
	ldx.w #$7d9e
	stx $2116
	ldx.w #$206a
	stx $2118
	ldx.w #$206c
	stx $2118
	ldx.w #$7dbe
	stx $2116
	ldx.w #$206b
	stx $2118
	ldx.w #$206d
	stx $2118
	ldx.w #$0202
	stx.w blockmap+$019e
	stx.w blockmap+$01be
	jsr DoAction
	bra bc_fall

DoAction
	ldx.w #$7c81
	stx $2116
	ldx.w #$0081
	ldy.w #$00
ba_line1
	stz.w blockmap,X
	sty.w $2118
	inx
	cpx.w #$008b
	BNE ba_line1
	ldx.w #$7ca1
	stx $2116
	ldx.w #$00a1
ba_line2
	stz.w blockmap,X
	sty.w $2118
	inx
	cpx.w #$00ab
	BNE ba_line2
	rts
