; equates
	FontAdr			equ lastvar2
	FontIdx			equ	FontAdr+$04
	FontPos			equ	FontIdx+$02
	FontOPos		equ	FontPos+$02
	FontWait		equ	FontOPos+$02
	FontUsePal		equ FontWait+$01
	lastvar3		equ	FontUsePal+$01

	BLINK_SPEED		equ $18
	FONT_SPEED		equ $08
	FLINE_SPEED		equ $10

TextScreen					; A = text, base = font, X : 0 no fadeout,FF = button
	php
	rep #$30
	phx
	pei.b (base)
	and.w #$00FF
	sta.b base
	lda.w #$0021
	sta.b adr
	jsr SetupText
	lda.w #$0010
	sta.b base
	pla
	sta.b adr
	lda.w #$0020
	jsr LoadPalette
	sep #$20
	lda #$02
	sta.b FontUsePal
	lda #$12
	sta $212c						; activate layer 1,S
	jsr FadeIn
ts_loop
	wai
	jsr FontUpdate
	lda.b FontWait
	BNE ts_loop	

	lda #$ff
	jsr WaitA

	plx
	sep #$10
	cpx #$FF
	bne no_button
	jsr WaitButton
no_button
	cpx #$00
	beq no_fadeout
	jsr FFfade
no_fadeout
	jsr FadeOut
	jsr ClearScreen
	plp
	rts

LoadFont
	php
	rep #$30
	lda.w #$6000
	sta.b base
	lda.w #font1&$FFFF
	sta.b adr
	lda.w #font1/$10000
	sta.b adr+$02
	sep #$20
	stz.b FontWait
	stz.b FontUsePal
	plp
	JMP LoadTiles			; load font

PrintText					; base = text nr, adr = screen pos
	php
	sep #$20
	rep #$10
	jsr SetupText
pt_loop
	lda #$01
	sta.b FontWait
	jsr FontUpdate
	lda.b FontWait
	BNE pt_loop
	plp
	rts

SetupText					; base = text nr. , adr = screen pos
	php
	rep #$30
	lda.b base
	asl
	tay
	lda.w TextTbl,Y			; get TextAdr
	clc
	adc.w #TextBin & $FFFF
	sta.b FontAdr
	lda.w #TextBin / $10000
	adc.w #$00
	sta.b FontAdr+$02		; store adr
	
	lda.b adr
	adc.w #$7c00
	sta.b FontPos			; set starting adr
	sta.b FontOPos			; set starting adr
	stz.b FontIdx
	sep #$20
	lda #$01
	sta.b FontWait
	stz.b FontIdx
		
	plp
	rts

FontUpdate
	lda.b FontWait
	BEQ t_Finish
	dec.b FontWait
	BNE t_Finish
	
	lda.b #FONT_SPEED
	sta.b FontWait			; wait counter

	ldy.b FontIdx
	ldx.b FontPos
	lda [FontAdr],Y			; load byte
	cmp #$FF
	BEQ t_Done
	cmp #$FE
	BEQ t_Wait
	cmp #$FD
	BEQ t_NextLine
	stx $2116				; write vram adr
	sta $2118
	lda.b FontUsePal
	asl
	asl
	ora #$20
	sta $2119
	inx
t_dontInc	
	stx.b FontPos
	iny
	sty.b FontIdx
t_Finish
	rts
t_Done
	stz.b FontWait
	BRA t_Finish
t_NextLine
	rep #$21
	stx $2116
	stz $2118
	lda.b FontOPos
	adc.w #$0020
	tax
	sta.b FontOPos
	sep #$20
	BRA t_dontInc
t_Wait
	lda.b #FLINE_SPEED
	sta.b FontWait
	BRA t_dontInc

ClearLine
	php
	sep #$10
	rep #$21
	lda.b adr
	adc.w #$7c00
	sta $2116
	ldx #$20
t_Loop
	stz $2118
	dex
	BNE t_Loop
	plp
	rts

ClearScreen
	php
	rep #$30
	ldx.w #$0400
	lda.w #$7c00
	sta $2116
clrs_loop
	stz $2118
	dex
	bne clrs_loop
	plp
	rts
