

JoypadUpdate
	lda $4212
	and #$01
	bne JoypadUpdate		; wait until the joypad is ready to read
	ldx $4218
	stx.b joy_lo			; read joypad state	

	cpx.b joy_old
	BEQ j_cont				; track changes
	
	lda.b PlayerState
	and #$85				; not when falling
	BNE j_knee
	lda.b joy_hi
	and #$80
	ora.b PlayerState
	sta.b PlayerState		; Update Jump state
	BEQ j_knee
	pha
	sta.b base
	JSR BoundaryCheck
	lda.b PlayerState
	cmp #$FE
	BEQ LevelFinish
	pla
	sta.b PlayerState
	BRA j_walk

j_knee
	and #$81
	BNE j_walk
	lda.b joy_old+$01
	eor.b joy_hi
	and #$04
	BEQ j_walk

	stx.b joy_old
	JMP KneeSetup
	
j_walk
	lda.b joy_hi
	and #$20
	BNE Die
	lda.b joy_old+$01
	eor.b joy_hi
	and #$03
	BEQ j_cont				; Move changes ?

	lda.b joy_hi
	and #$03
	BEQ j_reset				; stopped walking
	and #$01
	BEQ j_setNeg
	lda #$01
	bra j_setvar
j_setNeg
	lda #$FF
j_setvar
	sta.b PlayerMove		; Update Walk state
	and #$40
	sta.b Direction
	lda #$FC
	sta.b WalkPointer
	lda #$01
	sta.b WalkCounter		; stop walking
	
j_cont						; Checking
	stx.b joy_old
	stz.b base
	JSR BoundaryCheck
	lda.b PlayerState
	cmp #$FF
	BEQ j_finish
	eor.b PlayerStateOld
	and #$01
	BEQ j_finish
	JMP FallSetup	
j_finish
	rts 

j_reset
	stz.b PlayerMove
	lda.b PlayerState
	BNE j_cont
	stx.b joy_old
	JMP ResetPlayer

LevelFinish
	pla
	lda #$28
	jsr FFfx
	ldx.w #finishtable
	stx.b adr
	jsr TableSetup
	clc
lvlfin_loop
	wai
	jsr DisplayPlayer
	lda.b PlayerY
	sbc #$02
	sta.b PlayerY
	cmp #$06
	BCS lvlfin_loop
	rts
	
Die
	lda #$04
	sta.b joy_hi
	jsr KneeSetup
	stz.b PlayerMove
	lda #$22
	jsr FFfx
	lda #$40
	jsr WaitA
	clc
die_fall
	wai
	jsr DisplayPlayer
	lda.b PlayerY
	adc #$02
	sta.b PlayerY
	cmp #$dd
	BCC die_fall
	dec.b Lives
	lda.b #$FF
	sta.b PlayerState
	rts
