; graphic routines

LoadPal				; A=table adr
	php
	rep #$20
	sep #$10
	sta.b adr
	lda (adr)
	pha
	ldy #$02
	lda (adr),Y
	sta.b base
	ldy #$04
	lda (adr),Y
	sta.b adr
	pla
	plp
	jmp LoadPalette

LoadMap0			; X=table adr
	php
	pei.b (base)
	pei.b (adr)
	rep #$30
	stx.b adr
	sep #$10
	lda.w #$7800
	sta.b base
	ldy #$02
	lda (adr),Y
	sta.b bank
	lda.b (adr)
	sta.b adr
	jsr ForceBlank
	jsr LoadMap
	jsr UnBlank
	pla
	sta.b adr
	pla
	sta.b base
	plp
	rts

LoadMap1			; A=table adr
	php
	rep #$30
	sta.b adr
	sep #$10
	lda.w #$7c00
	sta.b base
	ldy #$02
	lda (adr),Y
	sta.b bank
	lda.b (adr)
	sta.b adr
	jsr LoadMap
	plp
	rts

LoadPalette:		; A=pos, base=len, adr
	php
	sep #$20
	sta $2121		; src
	rep #$31
	lda.b base
	and.w #$00FF
	asl
	sta.b base		; len
	sep #$20
	ldy.w #$00
_cpyloop
	lda (adr),Y
	sta $2122
	iny
	cpy.b base
	BNE _cpyloop
    plp
	rts

LoadTiles:			; base = VRAM pos, [adr] = data
	php
	sep #$30
    lda.b bank		; DMA source bank
    sta $4304
    
	rep #$21
	lda.b base		; set VRAM address
	sta $2116       
	lda.w #$1801    ; DMA dest = $2118, word adr
    sta $4300
	lda [adr]		; DMA size
	sta $4305
	lda.b adr		; DMA source offset
	inc
	inc
    sta $4302
    adc [adr]		; check for page overflow
	bcs lt_overflow
	ldx #$01        ; start dma
    stx $420B
    plp
	rts
lt_overflow
	lda.b adr
	clc
	adc.w #$0002
	eor.w #$FFFF
	adc.w #$0001
	sta $4305		; get new len
	lsr
	clc
	adc.b base
	sta.b base
	ldx #$01
	stx $420B		; start DMA
	ldx.b bank
	inx
	stx $4304		; new bank
	lda.w #$8000
	sta $4302		; new offset
	lda [adr]
	clc
	adc.w #$0002
	adc.b adr
	sta $4305		; new len
	lda.b base
	sta $2116		; new VRAM adr      
	lda.w #$1801    ; DMA dest = $2118, word adr
    sta $4300
	ldx #$01
	stx $420B		; start DMA
	plp
	rts

LoadMap:
	php
	rep #$30		; A,X,Y 16bit
	
	lda.b base	 	; set VRAM address
	sta $2116       
	lda.w #$1801    ; DMA dest = $2118, word adr
    sta $4300
	lda.w #$0800	; DMA size : 32x32 words
    sta $4305
	lda.b adr		; DMA source offset
    sta $4302
	
    sep #$20		; A 8bit

    lda.b bank		; DMA source bank
    sta $4304

    lda #$01        ; start dma
    sta $420B

    plp
	rts

LoadScene:			; A = adr
	php
	pha
	rep #$30
	sta.b adr
	ldy.w #$04
	lda (adr),Y
	sta.b base
	ldy.w #$06
	lda (adr),Y
	sta.b adr
	lda.w #$0010
	jsr LoadPalette
	pla
	pha
	sta.b adr
	lda.w #$3000
	sta.b base
	ldy.w #$0a
	lda (adr),Y
	sta.b bank
	ldy.w #$08
	lda (adr),Y
	sta.b adr
	jsr LoadTiles
	pla
	sta.b adr
	lda.w #$7800
	sta.b base
	ldy.w #$02
	lda (adr),Y
	sta.b bank
	lda.b (adr)
	sta.b adr
	jsr LoadMap
	plp
	rts

ClearScreen0
	php
	rep #$30
	ldx.w #$0400
	lda.w #$7800
	sta $2116
clr_loop
	stz $2118
	dex
	bne clr_loop
	plp
	rts
