; initialisation routines

InitSNES:
	lda #$8F        ; clear registers
	sta $2100
	stz $2101
	stz $2102
	stz $2103
	stz $2105
	stz $2106
	stz $2107
	stz $2108
	stz $2109
	stz $210A
	stz $210B
	stz $210C

	stz $210D
	stz $210D
	stz $210E
	stz $210E
	stz $210F
	stz $210F
	stz $2110
	stz $2110
	stz $2111
	stz $2111
	stz $2112
	stz $2112
	stz $2113
	stz $2113
	stz $2114
	stz $2114		; clear scroll regs
	
	lda #$80
	sta $2115
	stz $2116
	stz $2117
	stz $211A
	stz $211B
	lda #$01
	sta $211B
	stz $211C
	stz $211C
	stz $211D
	stz $211D
	stz $211E
	sta $211E
	stz $211F
	stz $211F
	stz $2120
	stz $2120
	stz $2121
	stz $2123
	stz $2124
	stz $2125
	stz $2126
	stz $2127
	stz $2128
	stz $2129
	stz $212A
	stz $212B
	stz $212C
	stz $212D
	stz $212E
	lda #$30
	sta $2130
	stz $2131
	lda #$E0
	sta $2132
	stz $2133

	stz $4200
	lda #$FF
	sta $4201
	stz $4202
	stz $4203
	stz $4204
	stz $4205
	stz $4206
	stz $4207
	stz $4208
	stz $4209
	stz $420A
	stz $420B
	stz $420C
	stz $420D
	rts

InitGfx:
	php
	sep #$20        ; A 8-bits
	
	lda #$01        ; graphics mode 1
	sta $2105

	lda #$00        ; disable playfield 0,1 and sprites
	sta $212c

	lda #$78        ; set playfield 0 map to $7800 (word)
	sta $2107
	lda #$7C        ; set playfield 1 map to $7C00 (word)
	sta $2108
	lda #$63        ; set tile sets (word) : pf 1=$6000, pf 0=$3000
	sta $210b
	lda #$60		; set sprite size to 16/32, starting at $0000 (word)
	sta $2101
	plp
	rts


ClearMemory:
	php
	rep #$30		; A,X,Y 16bit
	
	stz.b base		; clear var. base
	stz $2116       ; start at VRAM = $0000
	
	lda.w #$1805    ; DMA dest = $2118, fixed word adr
    sta $4300
	stz $4305		; DMA size = 64k
	stz $4302		; DMA source offset = var. base
		
    sep #$20		; A 8bit
    stz $4304		; DMA source bank = zero page
    
    lda #$01        ; start dma
    sta $420B
					; clear OAM table 1
	ldx.w #$0000
	stx $2102		; start at OAM  = $0000
oamloop
	stz $2104
	inx
	cpx.w #$0200	; 128 sprites  4 bytes
	bne oamloop
					; clear OAM table 2
	ldx.w #$0100
	stx $2102
	lda #$55		; set x msb
oamloop2
	sta $2104
	inx
	cpx.w #$0120
	bne oamloop2

	ldx.w #$0000	; clear blockmap area
blockloop
	stz.w blockmap,X
	inx
	cpx.w #$1000
	bne blockloop

	plp
	rts
