
	DPosX		equ lastvar6
	DRelX		equ DPosX+$01
	DTile		equ DRelX+$01
	lastvar7	equ DTile+$01

	Select1		equ $7d03
	Select2		equ $7d0c
	Select3		equ $7d14


IntroBla
	php
	rep #$10
	sep #$20
	lda #$01
	sta.b Intro
	ldx.w #SFX
	stx.b base
	jsr LoadMusic
	jsr StartMusic
	jsr VideoOn
	
	lda #$80
	jsr WaitA
	lda #$00
	jsr StartFX
	lda #$80
	jsr WaitA
	lda #$00
	jsr StartFX
	lda #$40
	jsr WaitA
	lda #$01
	jsr StartFX
	lda #$40
	jsr WaitA
	lda #$02
	jsr StartFX
	lda #$90
	jsr WaitA
	jsr VideoOff
	
	plp
	rts


DisplayLogo
	php
	rep #$30
	lda.w #ptFont
	jsr LoadPal
	lda.w #ptSprite
	jsr LoadPal
	lda.w #$7DCC		; setup logo map
	sta $2116
	lda.w #$0070
lg_loop
	sta $2118
	inc
	cmp.w #$0077
	bne lg_loop
	lda.w #$4070
	sta $2118
	lda.w #$7DEC
	sta $2116
	lda.w #$0077
lg_loop2
	sta $2118
	inc
	cmp.w #$007E
	bne lg_loop2
	lda.w #$4077
	sta $2118
	sep #$20
	lda #$12    
	sta $212c			; enable layer 1,S
	lda #$04
	sta $2110
	stz $2110			; scroll a little
	jsr VideoOn
	ldx.w #$0180
	jsr WaitX
	ldx.w #$E075
	stx.b base
	jsr SetupPlayer
	lda #$01
	sta.b PlayerState
	jsr FallSetup		; fall down
lg_mloop
	wai
	jsr DisplayPlayer
	jsr PlayerUpdate
	lda.b PlayerY
	cmp #$4C
	bne lg_mloop

	lda #$03
	jsr StartFX
						; wackelwackel
	lda #$04
	sta.b joy_hi
	jsr KneeSetup
	jsr DisplayPlayer
	ldx.w #wackeltable1
	stx.b adr
	jsr Wackel1
	
	lda #$4d
	sta.b PlayerY
	jsr ResetPlayer
	jsr DisplayPlayer
	lda #$30
	jsr WaitA
	
	lda #$40
	sta.b Direction
	jsr DisplayPlayer
	lda #$30
	jsr WaitA
	
	ldx.w #standtable
	stx.b adr
	jsr TableSetup
	jsr DisplayPlayer
	lda #$30
	jsr WaitA

	ldx.w #$3b75
	stx.b adr
	ldx.w #$0088
	stx.b base
	lda #$05
lg_questloop
	pha
	lda.b base
	eor.b #$02
	sta.b base
	jsr SpriteSetup		; QuestionMark
	lda #$20
	jsr WaitA
	pla
	dec
	bne lg_questloop
	
	jsr FadeOut
	stz $2110			; scroll back
	stz $2110
	ldx.w #$0100
	stx $2116
	lda #$55
	sta $2104
	sta $2104
	jsr StopFX
	rep #$20
	lda.w #$7DCC		; clean up
	sta $2116
	lda.w #$0028
lg_loop4
	stz $2118
	dec
	bne lg_loop4
	jsr HideSprites
	plp
	rts	

EntryText
	php
	rep #$30
	lda.w #IntroMusic
	sta.b base
	jsr LoadMusic
	lda.w #GreenPal
	sta.b base
	jsr StartMusic
	lda.w #$0000
	ldx.w #$0001
	jsr TextScreen
	jsr StopMusic
	plp
	rts

MinouMove
	dec DPosX
	BNE mn_finish
	lda.b #$03
	sta.b DPosX
	lda.b adr
	clc
	adc.b DRelX
	sta.b adr
	cmp #$a8
	BEQ set_fwd
	cmp #$c0
	BEQ set_bwd
	bit #$04
	BEQ minou2
	lda #$8c
	sta.b base
	BRA minouset
minou2
	lda #$8e
	sta.b base
minouset
	jsr SpriteSetup
mn_finish
	rts
set_fwd
	lda #$01
	sta.b DRelX
	lda #$40
	sta.b base+$01
mn_wait
	wai
	jsr SpriteSetup
	lda #$10
	sta.b DPosX
	BRA minouset
set_bwd
	lda #$FF
	sta.b DRelX
	stz.b base+$01
	BRA mn_wait

SecretLab
	php
	rep #$30
	lda.w #DevilsLab
	sta.b base
	jsr LoadMusic
	jsr StartMusic
	lda.w #$00e6
	sta.b DialogMagic
	stz.b FontUsePal
	lda.w #Lab1
	jsr LoadScene
	lda.w #$80c0
	sta.b adr
	lda.w #$008c
	sta.b base
	jsr SpriteSetup
	sep #$20
	lda #$03				; graphics mode 1
	sta $2105
	lda #$13				; enable layer 0,1,S
	sta $212c
	jsr FadeIn

	ldx.w #$0a00
	sep #$20
	lda.b #$FF
	sta.b DRelX
	lda.b #$01
	sta.b DPosX
moveloop
	phx
	wai
	jsr FontUpdate
	jsr MinouMove
	plx
	dex
	BEQ move_done
	cpx.w #$0902
	BEQ show_dlg
	cpx.w #$0603
	BEQ show_dlg
	cpx.w #$0304
	BEQ show_dlg
	cpx.w #$0180
	BNE moveloop
	ldx.w #Lab1
	jsr LoadMap0
	jsr ClearScreen
	ldx.w #$0020
	BRA moveloop
show_dlg
	phx
	pei.b (base)
	pei.b (adr)
	txa
	ldx.w #DocDlg
	stx.b adr
	jsr ShowDialog
	plx
	stx.b adr
	plx
	stx.b base
	plx
	BRA moveloop
move_done
	lda #$20
	jsr WaitA
	ldx.w #$828e
	stx.b adr
	ldx.w #$01a2
	stx.b base
	jsr SpriteSetup
	lda #$40
	jsr WaitA
	ldx.w #$70c0
	stx.b adr
	ldx.w #$0288
	stx.b base
	jsr SpriteSetup
	lda #$40
	jsr WaitA
	ldx.w #$01a2
	stx.b base
	ldx.w #$828e
	stx.b adr
	lda #$8e
mush_move
	wai
	wai
	wai
	sta.b adr
	pha
	jsr SpriteSetup
	pla
	inc
	cmp #$b8
	BNE mush_move
	ldx.w #$8100
	stx.b base
	jsr SpriteSetup
	ldx.w #$8200
	stx.b base
	jsr SpriteSetup
	lda #$20
	jsr WaitA
	ldx.w #wackeltable2
	stx.w adr
	jsr Wackel0
	stz $2100
	lda #$20
	jsr WaitA
	jsr UnBlank
	jsr Wackel0
	stz $2100
	lda #$20
	jsr WaitA
	jsr UnBlank
	jsr Wackel0
	ldx.w #Lab2
	jsr LoadMap0
	jsr HideSprites
	stz $2100
	lda #$20
	jsr WaitA
	jsr UnBlank
	lda #$20
	jsr WaitA
	ldx.w #$657c
	stx.b adr
	ldx.w #$00a0
	stx.b base
	jsr SpriteSetup
	lda #$30
	jsr WaitA
	jsr HideSprites
	ldx.w #DocDlg
	stx.b adr
	lda #$06
	jsr DoDialog
	ldx.w #MinouDlg
	stx.b adr
	lda #$07
	jsr DoDialog
	ldx.w #MinouDlg
	stx.b adr
	lda #$08
	jsr DoDialog
	ldx.w #MinouDlg
	stx.b adr
	lda #$09
	jsr DoDialog
	ldx.w #DocDlg
	stx.b adr
	lda #$0a
	jsr DoDialog
	
	jsr ClearScreen	
	ldx.w #Lab2
	jsr LoadMap0

	jsr FFfade
	jsr FadeOut
	jsr StopMusic
	
	plp
	rts


KathrinLogin
	php
	rep #$30
	jsr ClearScreen0
	lda.w #Edgar
	sta.b base
	jsr LoadMusic
	jsr StartMusic
	lda.w #GreenPal
	sta.b base
	lda.w #$000b
	ldx.w #$0000
	jsr TextScreen
	lda.w #ptSprite
	jsr LoadPal
	sep #$20
	lda #$13
	sta $212c
	ldx.w #$80ff
	stx.b base
	jsr SetupPlayer
	lda #$40
	stz.b PlayerVis
	sta.b Direction
	lda #$FF
	sta.b PlayerMove
	sta.b XBorder
	jsr FadeIn
k_moveloop
	wai
	jsr PlayerUpdate
	jsr DisplayPlayer
	lda.b PlayerX
	cmp.b #$70
	BCS k_moveloop
	jsr ResetPlayer
	jsr DisplayPlayer
	lda #$40
	jsr WaitA
	stz.b Direction
	jsr DisplayPlayer
	lda #$40
	jsr WaitA
	ldx.w #standtable
	stx.b adr
	jsr TableSetup
	jsr DisplayPlayer
	lda #$40
	jsr WaitA
	ldx.w #$6f6d
	stx.b adr
	ldx.w #$00a0
	stx.b base
	jsr SpriteSetup
	lda #$60
	jsr WaitA
	ldx.w #$80a0
	stx.b base
	jsr SpriteSetup
	lda #$40
	jsr WaitA
	ldx.w #KatrinDlg
	stx.b adr
	lda #$0d
	jsr DoDialog
	lda #$40
	jsr WaitA
	jsr FadeOut
	jsr HideSprites
	plp
	rts

StatusBla
	php
	rep #$30
	sep #$10
	lda.w #StatusKatrin
	ldx #$00
	jsr ShowStatus
	ldx #$01
	stx $212c
	stx $2105			; mode1, layer 0
	lda.w #VS
	jsr LoadScene
	jsr FadeIn
	lda.w #wackeltable2
	sta.b adr
	jsr Wackel0
	jsr FadeOut
	ldx #$03
	stx $212c
	stx $2105			; mode3, layer 0,1
	lda.w #StatusMinou
	jsr ShowStatus
	jsr StopMusic
	jsr ClearScreen0
	plp
	rts

ShowStatus		; A = status adr, X = 0 -> no fadeout
	php
	rep #$20
	sep #$10
	phx
	pha
	sta.b adr
	jsr MagicClear
	lda.w #$7c00
	sta.b base
	ldy.b #$02
	lda (adr),Y
	sta.b bank
	lda.b (adr)
	sta.b adr
	jsr LoadMap
	lda.w #ptBlue
	jsr LoadPal
	pla
	pha
	sta.b adr
	ldy #$0C
	lda (adr),Y
	jsr LoadPal
	lda.w #DialogPic
	sta.b base
	pla
	pha
	sta.b adr
	ldy #$10
	lda (adr),Y
	sta.b bank
	ldy #$0e
	lda (adr),Y
	sta.b adr
	jsr LoadTiles
	jsr LoadDlgPic
	jsr FadeIn
	
	jsr WaitButton
	lda.w #$0020
	jsr FFfx
	lda.w #Select2
	sta $2116
	stz $2118
	lda.w #Select1
	sta $2116
	lda.w #$205c
	sta $2118
	jsr WaitButton
	lda.w #$0028
	jsr FFfx
	lda.w #$7c00
	sta.b base
	pla
	pha
	sta.b adr
	ldy #$06
	lda (adr),Y
	sta.b bank
	ldy #$04
	lda (adr),Y
	sta.b adr
	jsr LoadMap
	jsr WaitButton
	lda.w #Select1
	sta $2116
	stz $2118
	lda.w #Select3
	sta $2116
	lda.w #$205c
	sta $2118
	lda.w #$0020
	jsr FFfx
	jsr WaitButton
	lda.w #$0028
	jsr FFfx
	lda.w #$7c00
	sta.b base
	pla
	sta.b adr
	ldy #$0a
	lda (adr),Y
	sta.b bank
	ldy #$08
	lda (adr),Y
	sta.b adr
	jsr LoadMap
	jsr WaitButton
	plx
	BEQ st_nofade
	jsr FFfade
st_nofade
	jsr FadeOut
	plp
	rts

ShowCastle
	php
	rep #$30
	lda.w #ptSprite
	jsr LoadPal
	lda.w #ptFont
	jsr LoadPal
	lda.w #IntroMusic
	sta.b base
	jsr LoadMusic
	lda.w #ptCastle
	jsr LoadPal
	lda.w #castlemap&$FFFF
	sta.b adr
	lda.w #castlemap/$10000
	sta.b bank
	lda.w #$7c00
	sta.b base
	jsr LoadMap
	jsr StartMusic
	lda.w #$b1a0
	sta.b base
	jsr SetupPlayer
	sep #$20
	stz.b PlayerVis
	lda #$13
	sta $212c
	lda #$03
	sta $2105
	jsr DisplayPlayer
	jsr FadeIn
	lda #$80
	jsr WaitA
	ldx.w #KatrinDlg
	stx.b adr
	lda #$0e
	jsr DoDialog
	ldx.w #MinouDlg
	stx.b adr
	lda #$10
	jsr WaitA
	lda #$0f
	jsr DoDialog
	ldx.w #AndiDlg
	stx.b adr
	lda #$10
	jsr WaitA
	lda #$11
	jsr DoDialog
	ldx.w #$a1a1
	stx.b adr
	ldx.w #$0088
	stx.b base
	jsr SpriteSetup
	lda #$10
	jsr WaitA
	
	jsr FFfade
	jsr FadeOut
	jsr StopMusic
	plp
	rts
