
DoLevels
	php
	sep #$20
	lda #$05
	sta.b Lives
	stz.b Intro
	rep #$10
	ldx.w #Level1
	jsr PlayLevel
	lda.b PlayerState
	cmp #$ff
	beq finish
	ldx.w #Level2
	jsr PlayLevel
	lda.b PlayerState
	cmp #$ff
	beq finish
	ldx.w #Level3
	jsr PlayLevel
	
finish
	plp
	rts

PlayLevel			; X =  level adr
	phx
restart_level	
	lda.b Lives
	BEQ GameOverPLX
	plx
	stx.b adr
	phx
	jsr Level
	lda.b PlayerState
	cmp #$FF						;? dead	
	beq restart_level
	plx
	rts

GameOverPLX
	plx
GameOver
	ldx.w #$7870
	stx.b PlayerX
	ldx.w #lietable
	stx.b adr
	jsr TableSetup
	jsr DisplayPlayer
	jsr ClearScreen0
	jsr ClearScreen
	ldx.w #Celes
	stx.b base
	jsr LoadMusic
	jsr StartMusic
	ldx.w #RedPal
	stx.w base
	lda #$10
	ldx.w #$FF
	jsr TextScreen
	jsr StopMusic
	rts

Level								; A = table adr
	php
	sep #$30
	jsr HideSprites
	lda #$13
	sta $212c						; activate layers 0,1,S
	lda #$01
	sta $2105						; video mode 1
	rep #$20
	ldy #$12
	lda (adr),Y
	pha
	ldy #$0e
	lda (adr),Y
	pha
	ldy #$0c
	lda (adr),Y
	pha
	ldy #$04
	lda (adr),Y
	pha
	ldy #$06
	lda (adr),Y
	pha
	lda.b (adr)
	pha
	ldy #$02
	lda (adr),Y
	pha
	ldy #$08
	lda (adr),Y
	pha
	ldy #$0a
	lda (adr),Y
	pha
	ldy #$10
	lda (adr),Y
	pha
	ldy #$14
	lda (adr),Y
	sta.b randomC
	pla
	sta.b base
	jsr LoadMusic
	jsr StartMusic
	lda.w #$3000
	sta.b base
	pla
	sta.b bank
	pla
	sta.b adr
	JSR LoadTiles					; Load background tiles
	lda.w #$7800
	sta.b base
	pla
	sta.b bank
	pla
	sta.b adr
	JSR LoadMap						; Load background map
	pla
	sta.b bank
	pla
	sta.b adr
	JSR LoadBlockMap				; Load foreground map
	pla
	sta.b adr
	lda.w #$0010
	sta.b base
	lda.w #$0020
	JSR LoadPalette
	lda.w #FontPal
	sta.b adr
	lda.w #$0020
	sta.b base
	lda.w #$0000
	JSR LoadPalette
	pla
	sta.b base
	JSR SetupPlayer
	JSR TetrisLoad
	JSR ShowLives
	jsr FadeIn
	pla
	rep #$10
	sep #$20
	sta.b TetrisSpeed

l1_loop
	wai
	jsr DisplayPlayer
	jsr FontUpdate
	jsr TetrisUpdate
	jsr PlayerUpdate
	jsr JoypadUpdate
	lda.b PlayerState
	Cmp #$FE
	BCC l1_loop
	
	jsr FFfade
	jsr FadeOut	
	jsr StopMusic
	plp
	rts


ShowLives
	php
	sep #$20
	rep #$10
	lda #$7c
	xba
	lda #$3f
	sec
	sbc.b Lives
	tax
	stx $2116
	ldx.w #$2456
	lda.b Lives
sh_loop
	stx $2118
	dec
	BNE sh_loop
	plp
	rts
