
; equates
	TetrisCount		equ	lastvar3
	TetrisPos		equ TetrisCount+$01
	TetrisTPos		equ TetrisPos+$08
	TetrisBlock		equ TetrisTPos+$08
	TetrisSpeed		equ TetrisBlock+$02
	TetrisGPtr		equ TetrisSpeed+$01
	TetrisCtrl		equ TetrisGPtr+$02
	TetrisState		equ TetrisCtrl+$01
	Lives			equ TetrisState+$01
	lastvar4		equ Lives+$01

	CTRL_SPEED		equ $07
	DOWN_SPEED		equ $03

TetrisLoad
	php
	sep #$20
	rep #$10
	lda #$0a
	sta.b TetrisSpeed
	stz.b TetrisCtrl
	sta.b TetrisCount
	jsr nt_setup
	plp
	rts

NextTetris
	ldx.b TetrisPos						; make old blocks undeadly
	lda.w blockmap,X
	and #$0F
	sta.w blockmap,X
	ldx.b TetrisPos+$02
	sta.w blockmap,X
	ldx.b TetrisPos+$04
	sta.w blockmap,X
	ldx.b TetrisPos+$06
	sta.w blockmap,X
	jsr CheckLines
nt_setup
	rep #$20
getrand
	jsr Rand16
	and.w #$01f0
	cmp.w #$01c0
	BCS getrand
	tay
	inc
	inc
	sta.b TetrisGPtr
	lda.w TetrisGen,Y
	sta.b TetrisBlock
	jsr RandC
	tax
	clc
	adc.w TetrisGen+$02,Y
	sta.b TetrisTPos
	jsr Checktris
	adc.w TetrisGen+$04,Y
	sta.b TetrisTPos+$02
	jsr Checktris
	adc.w TetrisGen+$06,Y
	sta.b TetrisTPos+$04
	jsr Checktris
	adc.w TetrisGen+$08,Y
	sta.b TetrisTPos+$06
	jsr Checktris
	lda.w TetrisTPos
	sta.w TetrisPos
	lda.w TetrisTPos+$02
	sta.w TetrisPos+$02
	lda.w TetrisTPos+$04
	sta.w TetrisPos+$04
	lda.w TetrisTPos+$06
	sta.w TetrisPos+$06
	sep #$20
	stz.b TetrisState
	rts

Checktris
	phy
	tay
	lda.w blockmap,Y
	and.w #$00FF
	BEQ chk_ok
	ply
	ply
	BRA nt_setup
chk_ok
	ply
	txa
	clc
	rts

TetrisUpdate
	lda.b TetrisCount
	BEQ te_finish
	dec
	sta.b TetrisCount
	BNE te_finish
	lda.b TetrisSpeed
	sta.b TetrisCount		; Counter stuff
te_start
	ldx.w #$00
te_loop3					; test blocks
	ldy.b TetrisPos,X
	lda.w blockmap+$20,Y    ; check in map for underblock
	BMI te_cont3
	BEQ te_cont3
	JMP NextTetris
te_cont3
	inx
	inx
	cpx.w #$08
	bne te_loop3
	
	rep #$21
	ldx.w #$00
te_loop						; clear old blocks
	lda.b TetrisPos,X
	adc.w #$7c00
	sta $2116
	stz $2118
	ldy.b TetrisPos,X
	sep #$20
	lda #$00
	sta.w blockmap,Y
	rep #$20
	inx
	inx
	cpx.w #$08
	bne te_loop
	
	lda.b TetrisPos+$06
	cmp.w #$0380
	BCS te_fallthrough
	
	ldx.w #$00
te_loop2					; set new blocks
	lda.b TetrisPos,X
	clc
	adc.w #$0020
	sta.b TetrisPos,X
	adc.w #$7c00
	sta $2116
	ldy.b TetrisBlock
	sty $2118
	ldy.b TetrisPos,X
							; set in map
	sep #$20
	lda.b TetrisBlock
	and #$0F
	inc
	ora #$80				; deadly tetris block flag :)
	sta.w blockmap,Y
	rep #$20
	inx
	inx
	cpx.w #$08
	bne te_loop2
	
	sep #$20
	
te_finish
	rts

te_fallthrough
	lda.w #$38d0
	sta.b TetrisPos
	sta.b TetrisPos+$02
	sta.b TetrisPos+$04
	sta.b TetrisPos+$06
	JMP nt_setup

TetrisControl
	php
	sep #$20
	rep #$10
	lda #$2c
	jsr	FFfx
	lda #$01
	sta.b TetrisCtrl
	ldx.b joy_lo
	stx.b joy_old
ctrl_loop
	wai
	jsr TetrisUpdate
	dec.b TetrisCtrl
	BNE ctrl_loop
	lda #$01
	sta.b TetrisCtrl
joy_loop
	lda $4212
	and #$01
	bne joy_loop			; wait until the joypad is ready to read
	ldx $4218
	stx.b joy_lo			; read joypad state	
	
	lda.b joy_hi
	BPL joy_t1
	lda.b joy_old+$01
	BMI joy_t1 
	jsr ControlRotate
	BRA ctrl_2loop
joy_t1
	bit #$40
	BNE ctrl_fin	
joy_move
	bit #$04
	BEQ joy_lr
	lda #$01
	sta.b TetrisCount
	lda #DOWN_SPEED
	sta.b TetrisCtrl
	lda.b joy_hi	
joy_lr
	bit #$03
	BEQ no_move
	and #$01
	BEQ ctrl_left
	ldy.w #$01
	BRA ctrl_move
ctrl_left
	ldy.w #$FFFF
ctrl_move
	sty.b base
	jsr ControlMove
	
no_move

ctrl_2loop
	ldx.b joy_lo
	stx.b joy_old
	BRA ctrl_loop
ctrl_fin
	lda #$2c
	jsr FFfx
	plp
	rts

ControlMove				; base = delta x
	php
	rep #$20
	sep #$10
	ldy #CTRL_SPEED
	sty.b TetrisCtrl
	ldy #$00
	lda.b TetrisGPtr
	sta.b temp
move_loop
	lda.b TetrisPos,Y
	clc
	adc.b base
	sta.b TetrisTPos,Y
	iny
	iny
	cpy #$08
	BNE move_loop
	plp
	BRA TetrisTest

ControlRotate
	php
	rep #$31
	lda.b TetrisGPtr
	tax
	adc.w #$0010
	and.w #$003F
	sta.b base
	lda.b TetrisGPtr
	and.w #$FFC0
	ora.b base
	sta.b base
	sta.b temp
	ldy.w #$00					; get new ref. tile pos
rot_loop
	lda.b TetrisPos,Y
	sec
	sbc.w TetrisGen,X
	clc
	adc.w TetrisCor,X
	phx
	ldx.b base
	clc
	adc.w TetrisGen,X
	plx
	sta.b TetrisTPos,Y
	inx
	inx
	iny
	iny
	inc.b base
	inc.b base
	cpy.w #$08
	BNE rot_loop
	plp
	BRA TetrisTest

TetrisTest
	php
	rep #$30
	ldy.w #$00
test_loop
	lda.b TetrisTPos,Y
	and.w #$001F
	cmp.w #$000B
	BCC test_fail
	cmp.w #$0014
	BCS test_fail
	ldx.b TetrisTPos,Y
	sep #$20
	lda.w blockmap,X
	BMI test_ok
	BNE test_fail
test_ok
	rep #$20
	iny
	iny
	cpy.w #$08
	BNE test_loop
	
	ldy.w #$00
test_clear
	lda.b TetrisPos,Y
	tax
	clc
	adc.w #$7c00
	sta $2116
	stz $2118
	sep #$20
	stz.w blockmap,X
	rep #$20
	iny
	iny
	cpy.w #$08
	bne test_clear
	
	ldy.w #$00
test_trans
	lda.b TetrisTPos,Y
	sta.b TetrisPos,Y
	tax
	clc
	adc.w #$7c00
	sta $2116
	lda.w TetrisBlock
	sta $2118
	sep #$20
	and #$0F
	inc
	ora #$80
	sta.w blockmap,X
	rep #$20
	iny
	iny
	cpy.w #$08
	BNE test_trans
	lda.b temp
	sta.b TetrisGPtr
	
test_fail
	plp
	rts

CheckLines
	php
	sep #$20
	rep #$10
	ldx.w #$02EB
check_line
	lda.w blockmap,X
	BEQ next_line
	inx
	txa
	and #$1F
	cmp #$14
	BNE check_line
	phx
	lda #$2c
	jsr FFfx
	jsr MoveBlock
	plx
next_line
	rep #$20
	txa
	and.w #$FFE0
	ora.w #$000B
	sec
	sbc.w #$0020
	tax
	cmp.w #$00AB
	sep #$20
	BNE check_line

	plp
	rts

MoveBlock
	rep #$20
	txa
	and.w #$FFE0
	ora.w #$000B
	sec
	sbc.w #$0020
	tax
	clc
	adc.w #$7c20
	sta $2116
	sep #$20
mv_line
	lda.w blockmap,X
	sta.w blockmap+$20,X
	BEQ mv_store
	dec
	ora #$50
mv_store
	sta $2118
	lda #$24
	sta $2119
	inx
	txa
	and #$1F
	cmp #$14
	BNE mv_line
	rep #$20
	txa
	cmp.w #$00B4
	BNE MoveBlock
	rts
