; GFX tools

FadeOut:
    php
    sep #$20        ; A 8-bits
	lda #$0F
fadeOutLoop
	sta $2100
    wai
	wai
	dec
	BPL fadeOutLoop
	lda #$80        ; disable screen
	sta $2100
    stz $4200		; disable vertical blank interrupt & joypad read
	stz $2131
	plp
	sei				; disable int's
	rts

FadeIn:
    cli				; enable int's
	php
    sep #$20        ; A 8-bits
	lda #$81        ; enable vertical blank interrupt & joypad read
	sta $4200
	sep #$20
	lda #$00
fadeInLoop
	sta $2100
    wai
	wai
	inc
	cmp #$10
	bne fadeInLoop
	plp
	rts

VideoOn:
	php
	sep #$20        ; A 8-bits
	lda #$81        ; enable vertical blank interrupt & joypad read
	sta $4200
	lda #$0F
	sta $2100		; screen on
	plp
	cli				; enable int's
	rts

VideoOff:
	sei				; disable int's
	php
	sep #$20
	lda #$80        ; disable screen
	sta $2100
    stz $4200		; disable vertical blank interrupt & joypad read
	plp
	rts

ForceBlank
	sei
	php
	sep #$20
	lda #$8f
	sta $2100
	plp
	rts

UnBlank
	php
	sep #$20
	lda #$0f
	sta $2100
	plp
	cli
	rts

verticalBlankInterrupt:
	rti

Wackel1
	php
	sep #$30
	ldy #$00
wa_loop
	lda (adr),Y
	cmp #$FF
	BEQ wa_done
	sta $2110
	stz $2110
	iny
	wai
	wai
	bra wa_loop
wa_done
	plp
	rts

Wackel0
	php
	sep #$30
	ldy #$00
wa1_loop
	lda (adr),Y
	cmp #$FF
	BEQ wa1_done
	sta $210E
	stz $210E
	iny
	wai
	wai
	bra wa1_loop
wa1_done
	plp
	rts

WaitA
	wai
	dec
	bne WaitA
	rts
WaitX
	wai
	dex
	bne WaitX
	rts
WaitY
	wai
	dex
	bne WaitY
	rts

SetupRandom			; seed value 00-3F in random
	php
	sep #$30
	lda.b random
	and #$3f
	tay
	lda.w RandomTable,Y
	sta.b random
	lda.w RandomTable+$02,Y
	sta.b random+$02
	plp
	rts

Rand8
	lda.b random+$02
	sta.b random+$03
	lda.b random+$01
	sta.b random+$02
	lda.b random
	sta.b random+$01
	cmp.b random+$02
	BMI R2_Greater
	lda.b random+$02
R2_Greater
	clc
	adc.b random+$03
	sta.b random
	rts

Rand16
	sep #$20
	jsr Rand8
	xba
	jsr Rand8
	rep #$20
	rts

RandC
	lda.w #$0000
	sep #$20
getnew
	jsr Rand8
	and #$1F
	cmp.b randomC
	bcs getnew
	cmp.b randomC+$01
	bcc getnew
	rep #$20
	rts

WaitButton
	php
	sep #$30
	wai
WaitForPad
	inc.b random
	lda $4212
	and #$01
	bne WaitForPad	
	lda $4219
	and #$40
	BNE WaitForPad			; already pressed ?	
	wai
WaitForPad2
	inc.b random
	lda $4212
	and #$01
	bne WaitForPad2
	lda $4219
	and #$40
	BEQ WaitForPad2
	plp
	rts
